subroutine param_CorrMov(CorrMov_par)
  use CorrMov_types
  use sep

  implicit none
  type (CorrMov_param_type) CorrMov_par
  character(len=128) :: tag_name

  integer ::  omp_get_num_threads
  integer n_threads_env,n_threads_init
  integer ierr
  integer n1,n2,n3,n4,n5
  integer, external :: auxpar,getch,fetch,auxin,auxinout,sreed,sseek,auxout
  real o1,o2,o3,o4,o5,d1,d2,d3,d4,d5

  n_threads_init=1

  call from_param('verb',CorrMov_par%verb,.false.)
  call from_param('debug1',CorrMov_par%debug1,.false.)
  call from_param('debug2',CorrMov_par%debug2,.false.)

  call from_param('n_threads',CorrMov_par%n_threads,n_threads_init)
  call from_param('max_memory',CorrMov_par%max_memory,100)

  call from_param('first_adj',CorrMov_par%first_adj,.false.)
  call from_param('first_add',CorrMov_par%first_add,.false.)

  call from_param('test',CorrMov_par%test,.false.)

  ! checking parameters
!$omp parallel
  n_threads_env=omp_get_num_threads()
!$omp end parallel
  if(CorrMov_par%n_threads == n_threads_init) then
     CorrMov_par%n_threads=n_threads_env
  else
     if(n_threads_env > CorrMov_par%n_threads) then
        call omp_set_num_threads(CorrMov_par%n_threads)
        write(0,*)'WARNING: overwriting environment variable'
        write(0,*)'CorrMov_par-n_threads=',CorrMov_par%n_threads
     end if
     if(n_threads_env < CorrMov_par%n_threads) then
        write(0,*)'CorrMov_par-n_threads=',CorrMov_par%n_threads
        write(0,*)'OMP_NUM_THREADS=',n_threads_env
        call seperr('ERROR: Asked for more threads than the environment variable allows')
     end if
  end if


    call from_history('esize',CorrMov_par%esize)
    if(CorrMov_par%esize /= 4) call seperr("Input should be real")

    call from_history('n1',CorrMov_par%n1)
    call from_history('n2',CorrMov_par%n2)
    call from_history('n3',CorrMov_par%n3)
    call from_history('n4',CorrMov_par%n4,1)
    call from_history('n5',CorrMov_par%n5,1)
    call from_history('n6',CorrMov_par%n6,1)
    
    call from_history('d1',CorrMov_par%d1)
    call from_history('d2',CorrMov_par%d2)
    call from_history('d3',CorrMov_par%d3)
    call from_history('d4',CorrMov_par%d4,1.)
    call from_history('d5',CorrMov_par%d5,1.)
    call from_history('d6',CorrMov_par%d6,1.)
    
    call from_history('o1',CorrMov_par%o1)
    call from_history('o2',CorrMov_par%o2)
    call from_history('o3',CorrMov_par%o3)
    call from_history('o4',CorrMov_par%o4,0.)
    call from_history('o5',CorrMov_par%o5,0.)
    call from_history('o6',CorrMov_par%o6,0.)

    CorrMov_par%oper_type='none'
    call from_param('oper_type',CorrMov_par%oper_type, &
           trim(CorrMov_par%oper_type))

    select case (CorrMov_par%oper_type(1:3))
    case ('pic')
       CorrMov_par%oper_type(1:11)='pick_maxima'
    case ('dso')
       CorrMov_par%oper_type(1:3)='dso'
    case ('sta')
       CorrMov_par%oper_type(1:5)='stack'
    case ('l-s')
       CorrMov_par%oper_type(1:7)='l-stack'
    case ('b-f')
       CorrMov_par%oper_type(1:6)='b-form'
    case default
       write(0,*)'CorrMov_par-oper_type=',trim(CorrMov_par%oper_type)
       call seperr('Not supported oper_type')
    end select
    if(CorrMov_par%verb) then
      write(0,*)'CorrMov_par-oper_type=',trim(CorrMov_par%oper_type)
    end if
  
  
    select case (CorrMov_par%oper_type(1:3))
    case ('pic')
    !{
      CorrMov_par%n1_max=CorrMov_par%n2
      CorrMov_par%n2_max=CorrMov_par%n3
      CorrMov_par%n3_max=CorrMov_par%n4
      CorrMov_par%n4_max=CorrMov_par%n5

      CorrMov_par%o1_max=CorrMov_par%o2
      CorrMov_par%o2_max=CorrMov_par%o3
      CorrMov_par%o3_max=CorrMov_par%o4
      CorrMov_par%o4_max=CorrMov_par%o5

      CorrMov_par%d1_max=CorrMov_par%d2
      CorrMov_par%d2_max=CorrMov_par%d3
      CorrMov_par%d3_max=CorrMov_par%d4
      CorrMov_par%d4_max=CorrMov_par%d5
  
!      call from_param('tag_max',CorrMov_par%tag_max,'Max')
!      call from_param(trim(CorrMov_par%tag_max),tag_name,'Max not found')
!      ierr=auxout(trim(CorrMov_par%tag_max))
!      write(0,*)'auxout ierr=',ierr
  
      call to_history("title","Picked maxima")
  
      call to_history("esize",CorrMov_par%esize)

      call to_history("n1",CorrMov_par%n1_max)
      call to_history("n2",CorrMov_par%n2_max)
      call to_history("n3",CorrMov_par%n3_max)
      call to_history("n4",CorrMov_par%n4_max)
      call to_history("n5",1)

      call to_history("o1",CorrMov_par%o1_max)
      call to_history("o2",CorrMov_par%o2_max)
      call to_history("o3",CorrMov_par%o3_max)
      call to_history("o4",CorrMov_par%o4_max)

      call to_history("d1",CorrMov_par%d1_max)
      call to_history("d2",CorrMov_par%d2_max)
      call to_history("d3",CorrMov_par%d3_max)
      call to_history("d4",CorrMov_par%d4_max)

      call from_param('pick_threshold',CorrMov_par%pick_threshold,-1.)

    !}
    case ('dso')
    !{

      call to_history("title","DSO")
  
      call to_history("esize",CorrMov_par%esize)

      call to_history("n1",CorrMov_par%n1)
      call to_history("n2",CorrMov_par%n2)
      call to_history("n3",CorrMov_par%n3)
      call to_history("n4",CorrMov_par%n4)
      call to_history("n5",CorrMov_par%n5)

      call to_history("o1",CorrMov_par%o1)
      call to_history("o2",CorrMov_par%o2)
      call to_history("o3",CorrMov_par%o3)
      call to_history("o4",CorrMov_par%o4)
      call to_history("o5",CorrMov_par%o5)

      call to_history("d1",CorrMov_par%d1)
      call to_history("d2",CorrMov_par%d2)
      call to_history("d3",CorrMov_par%d3)
      call to_history("d4",CorrMov_par%d4)
      call to_history("d5",CorrMov_par%d5)

      call from_param('dso_threshold',CorrMov_par%dso_threshold,-1.)

      call from_param('dso_min1',CorrMov_par%dso_min1,CorrMov_par%o1)
      call from_param('dso_max1',CorrMov_par%dso_max1, &
               CorrMov_par%o1+(CorrMov_par%n1-1)*CorrMov_par%d1)
      call from_param('dso_min2',CorrMov_par%dso_min2,CorrMov_par%o2)
      call from_param('dso_max2',CorrMov_par%dso_max2, &
               CorrMov_par%o2+(CorrMov_par%n2-1)*CorrMov_par%d2)

      call from_param('r_weights_dso',CorrMov_par%r_weights_dso,.false.)
      call from_param('l_weights_dso',CorrMov_par%l_weights_dso,.false.)

      if(CorrMov_par%r_weights_dso) then
      !{
        call from_param('dso_epsi',CorrMov_par%dso_epsi,.001)

        call from_param('tag_r_weights',CorrMov_par%tag_r_weights,'R_Weights')
        call from_param(trim(CorrMov_par%tag_r_weights), &
              tag_name,'R_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_r_weights))
!        write(0,*)'auxin ierr=',ierr

        call from_aux(trim(CorrMov_par%tag_r_weights),"n1",n1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n2",n2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n3",n3,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n4",n4,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o2",o2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o3",o3,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o4",o4,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d2",d2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d3",d3,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d4",d4,CorrMov_par%d5)

        if (n1 /= CorrMov_par%n2) then
          write(0,*)'R_Weights: n1=',n1,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n3) then
          write(0,*)'R_Weights: n2=',n2,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n4) then
          write(0,*)'R_Weights: n3=',n3,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n5) then
          write(0,*)'R_Weights: n4=',n4,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= CorrMov_par%o2) then
          write(0,*)'R_Weights: o1=',o1,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o3) then
          write(0,*)'R_Weights: o2=',o2,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o4) then
          write(0,*)'R_Weights: o3=',o3,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o5) then
          write(0,*)'R_Weights: o4=',o4,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'R_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d3) then
          write(0,*)'R_Weights: d2=',d2,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d4) then
          write(0,*)'R_Weights: d3=',d3,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d5) then
          write(0,*)'R_Weights: d4=',d4,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if

      if(CorrMov_par%l_weights_dso) then
      !{
        call from_param('tag_l_weights',CorrMov_par%tag_l_weights,'L_Weights')
        call from_param(trim(CorrMov_par%tag_l_weights), &
              tag_name,'L_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_l_weights))
!        write(0,*)'auxin ierr=',ierr

        call from_aux(trim(CorrMov_par%tag_l_weights),"n1",n1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n2",n2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n3",n3,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n4",n4,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_l_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o2",o2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o3",o3,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o4",o4,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_l_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d2",d2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d3",d3,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d4",d4,CorrMov_par%d5)

        if (n1 /= CorrMov_par%n2) then
          write(0,*)'L_Weights: n1=',n1,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n3) then
          write(0,*)'L_Weights: n2=',n2,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n4) then
          write(0,*)'L_Weights: n3=',n3,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n5) then
          write(0,*)'L_Weights: n4=',n4,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= CorrMov_par%o2) then
          write(0,*)'L_Weights: o1=',o1,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o3) then
          write(0,*)'L_Weights: o2=',o2,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o4) then
          write(0,*)'L_Weights: o3=',o3,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o5) then
          write(0,*)'L_Weights: o4=',o4,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'L_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d3) then
          write(0,*)'L_Weights: d2=',d2,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d4) then
          write(0,*)'L_Weights: d3=',d3,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d5) then
          write(0,*)'L_Weights: d4=',d4,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if

    !}
    case ('sta')
    !{
!      call from_param('first_adj',CorrMov_par%first_adj,.false.)
!      call from_param('first_add',CorrMov_par%first_add,.false.)

      call from_param('norm_stack',CorrMov_par%norm_stack,.false.)
      call from_param('unitary_stack',CorrMov_par%unitary_stack,.false.)

      if(CorrMov_par%first_adj) then
      !{
        call to_history("title","Adjoint Stack")
        CorrMov_par%n5=CorrMov_par%n4
        CorrMov_par%n4=CorrMov_par%n3
        CorrMov_par%n3=CorrMov_par%n2

        CorrMov_par%o5=CorrMov_par%o4
        CorrMov_par%o4=CorrMov_par%o3
        CorrMov_par%o3=CorrMov_par%o2

        CorrMov_par%d5=CorrMov_par%d4
        CorrMov_par%d4=CorrMov_par%d3
        CorrMov_par%d3=CorrMov_par%d2

        call from_history('n2_stack',CorrMov_par%n2,Huge(CorrMov_par%n2))
        call from_history('o2_stack',CorrMov_par%o2,Huge(CorrMov_par%o2))
        call from_history('d2_stack',CorrMov_par%d2,Huge(CorrMov_par%d2))

!       write(0,*)'n2_ad_stac=',CorrMov_par%n2_adj_stack 
!       write(0,*)'HUGE n2_ad_stac=',Huge(CorrMov_par%n2_adj_stack)
!       write(0,*)'o2_ad_stac=',CorrMov_par%o2_adj_stack 
!       write(0,*)'HUGE o2_ad_stac=',Huge(CorrMov_par%o2_adj_stack)
!       write(0,*)'d2_ad_stac=',CorrMov_par%d2_adj_stack 
!       write(0,*)'HUGE d2_ad_stac=',Huge(CorrMov_par%d2_adj_stack)

        if(CorrMov_par%n2 == Huge(CorrMov_par%n2)) &
          call from_param('n2_out',CorrMov_par%n2)
        if(CorrMov_par%o2 == Huge(CorrMov_par%o2)) &
          call from_param('o2_out',CorrMov_par%o2)
        if(CorrMov_par%d2 == Huge(CorrMov_par%d2)) &
          call from_param('d2_out',CorrMov_par%d2)

        call to_history("n1",CorrMov_par%n1)
        call to_history("n2",CorrMov_par%n2)
        call to_history("n3",CorrMov_par%n3)
        call to_history("n4",CorrMov_par%n4)
        call to_history("n5",CorrMov_par%n5)
  
        call to_history("o1",CorrMov_par%o1)
        call to_history("o2",CorrMov_par%o2)
        call to_history("o3",CorrMov_par%o3)
        call to_history("o4",CorrMov_par%o4)
        call to_history("o5",CorrMov_par%o5)
  
        call to_history("d1",CorrMov_par%d1)
        call to_history("d2",CorrMov_par%d2)
        call to_history("d3",CorrMov_par%d3)
        call to_history("d4",CorrMov_par%d4)
        call to_history("d5",CorrMov_par%d5)

      !}
      else
      !{
        call to_history("title","Stack")
    
        call to_history("esize",CorrMov_par%esize)
  
        call to_history("n1",CorrMov_par%n1)
        call to_history("n2",CorrMov_par%n3)
        call to_history("n3",CorrMov_par%n4)
        call to_history("n4",CorrMov_par%n5)
        call to_history("n5",1)
  
        call to_history("o1",CorrMov_par%o1)
        call to_history("o2",CorrMov_par%o3)
        call to_history("o3",CorrMov_par%o4)
        call to_history("o4",CorrMov_par%o5)
        call to_history("o5",0.)
  
        call to_history("d1",CorrMov_par%d1)
        call to_history("d2",CorrMov_par%d3)
        call to_history("d3",CorrMov_par%d4)
        call to_history("d4",CorrMov_par%d5)
        call to_history("d5",1.)

        call to_history('n2_stack',CorrMov_par%n2)
        call to_history('o2_stack',CorrMov_par%o2)
        call to_history('d2_stack',CorrMov_par%d2)
      !}
      end if

      call from_param('r_weights_stack',CorrMov_par%r_weights_stack,.false.)

      if(CorrMov_par%r_weights_stack) then
      !{
        call from_param('stack_epsi',CorrMov_par%stack_epsi,.001)

        call from_param('tag_r_weights',CorrMov_par%tag_r_weights,'R_Weights')
        call from_param(trim(CorrMov_par%tag_r_weights), &
              tag_name,'R_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_r_weights))
!        write(0,*)'auxin ierr=',ierr

        call from_aux(trim(CorrMov_par%tag_r_weights),"n1",n1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n2",n2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n3",n3,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n4",n4,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o2",o2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o3",o3,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o4",o4,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d2",d2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d3",d3,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d4",d4,CorrMov_par%d5)

        if (n1 /= CorrMov_par%n2) then
          write(0,*)'R_Weights: n1=',n1,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n3) then
          write(0,*)'R_Weights: n2=',n2,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n4) then
          write(0,*)'R_Weights: n3=',n3,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n5) then
          write(0,*)'R_Weights: n4=',n4,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= CorrMov_par%o2) then
          write(0,*)'R_Weights: o1=',o1,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o3) then
          write(0,*)'R_Weights: o2=',o2,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o4) then
          write(0,*)'R_Weights: o3=',o3,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o5) then
          write(0,*)'R_Weights: o4=',o4,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'R_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d3) then
          write(0,*)'R_Weights: d2=',d2,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d4) then
          write(0,*)'R_Weights: d3=',d3,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d5) then
          write(0,*)'R_Weights: d4=',d4,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if

    !}
    case ('l-s')
    !{

      call from_param('norm_lstack',CorrMov_par%norm_lstack,.false.)
      call from_param('unitary_lstack',CorrMov_par%unitary_lstack,.false.)
      call from_param('asym_lstack',CorrMov_par%asym_lstack,.false.)

      if(CorrMov_par%first_adj) then
        call from_param('h_width_lstack',CorrMov_par%h_width_lstack,-1)
        if(CorrMov_par%h_width_lstack == -1) then
          call from_history('h_width_lstack',CorrMov_par%h_width_lstack)
          call to_history('From stdin: h_width_lstack', &
            CorrMov_par%h_width_lstack)
        end if
      else
        call from_param('h_width_lstack',CorrMov_par%h_width_lstack)
      end if
      

      call to_history("title","Local stack")
  
      call to_history("esize",CorrMov_par%esize)

      call to_history("n1",CorrMov_par%n1)
      call to_history("n2",CorrMov_par%n2)
      call to_history("n3",CorrMov_par%n3)
      call to_history("n4",CorrMov_par%n4)
      call to_history("n5",CorrMov_par%n5)

      call to_history("o1",CorrMov_par%o1)
      call to_history("o2",CorrMov_par%o2)
      call to_history("o3",CorrMov_par%o3)
      call to_history("o4",CorrMov_par%o4)
      call to_history("o5",CorrMov_par%o5)

      call to_history("d1",CorrMov_par%d1)
      call to_history("d2",CorrMov_par%d2)
      call to_history("d3",CorrMov_par%d3)
      call to_history("d4",CorrMov_par%d4)
      call to_history("d5",CorrMov_par%d5)

      call from_param('lstack_threshold',CorrMov_par%lstack_threshold,-1.)

      call from_param('lstack_min1',CorrMov_par%lstack_min1,CorrMov_par%o1)
      call from_param('lstack_max1',CorrMov_par%lstack_max1, &
               CorrMov_par%o1+(CorrMov_par%n1-1)*CorrMov_par%d1)
      call from_param('lstack_min2',CorrMov_par%lstack_min2,CorrMov_par%o2)
      call from_param('lstack_max2',CorrMov_par%lstack_max2, &
               CorrMov_par%o2+(CorrMov_par%n2-1)*CorrMov_par%d2)

      call from_param('r_weights_lstack',CorrMov_par%r_weights_lstack,.false.)
      call from_param('l_weights_lstack',CorrMov_par%l_weights_lstack,.false.)

      if(CorrMov_par%r_weights_lstack) then
      !{
        call from_param('lstack_epsi',CorrMov_par%lstack_epsi,.001)

        call from_param('tag_r_weights',CorrMov_par%tag_r_weights,'R_Weights')
        call from_param(trim(CorrMov_par%tag_r_weights), &
              tag_name,'R_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_r_weights))
!        write(0,*)'auxin ierr=',ierr

        call from_aux(trim(CorrMov_par%tag_r_weights),"n1",n1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n2",n2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n3",n3,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n4",n4,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o2",o2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o3",o3,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o4",o4,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d2",d2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d3",d3,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d4",d4,CorrMov_par%d5)

        if (n1 /= CorrMov_par%n2) then
          write(0,*)'R_Weights: n1=',n1,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n3) then
          write(0,*)'R_Weights: n2=',n2,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n4) then
          write(0,*)'R_Weights: n3=',n3,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n5) then
          write(0,*)'R_Weights: n4=',n4,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= CorrMov_par%o2) then
          write(0,*)'R_Weights: o1=',o1,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o3) then
          write(0,*)'R_Weights: o2=',o2,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o4) then
          write(0,*)'R_Weights: o3=',o3,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o5) then
          write(0,*)'R_Weights: o4=',o4,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'R_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d3) then
          write(0,*)'R_Weights: d2=',d2,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d4) then
          write(0,*)'R_Weights: d3=',d3,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d5) then
          write(0,*)'R_Weights: d4=',d4,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if

      if(CorrMov_par%l_weights_lstack) then
      !{
        call from_param('tag_l_weights',CorrMov_par%tag_l_weights,'L_Weights')
        call from_param(trim(CorrMov_par%tag_l_weights), &
              tag_name,'L_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_l_weights))
!        write(0,*)'auxin ierr=',ierr

        call from_aux(trim(CorrMov_par%tag_l_weights),"n1",n1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n2",n2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n3",n3,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n4",n4,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_l_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o2",o2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o3",o3,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o4",o4,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_l_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d2",d2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d3",d3,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d4",d4,CorrMov_par%d5)

        if (n1 /= CorrMov_par%n2) then
          write(0,*)'L_Weights: n1=',n1,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n3) then
          write(0,*)'L_Weights: n2=',n2,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n4) then
          write(0,*)'L_Weights: n3=',n3,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n5) then
          write(0,*)'L_Weights: n4=',n4,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= CorrMov_par%o2) then
          write(0,*)'L_Weights: o1=',o1,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o3) then
          write(0,*)'L_Weights: o2=',o2,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o4) then
          write(0,*)'L_Weights: o3=',o3,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o5) then
          write(0,*)'L_Weights: o4=',o4,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'L_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d3) then
          write(0,*)'L_Weights: d2=',d2,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d4) then
          write(0,*)'L_Weights: d3=',d3,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d5) then
          write(0,*)'L_Weights: d4=',d4,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if

    !}

    case ('b-f')
    !{

!      call from_param('norm_bstack',CorrMov_par%norm_bstack,.false.)
!      call from_param('unitary_bstack',CorrMov_par%unitary_bstack,.false.)
!      call from_param('asym_bstack',CorrMov_par%asym_bstack,.false.)

      call to_history("esize",CorrMov_par%esize)
      call from_param('beam_weight_power',CorrMov_par%beam_weight_power,0.)

      if(CorrMov_par%first_adj) then
      !{
        call to_history("title","Beam-forming (adj)")

        CorrMov_par%h_width_bform=(CorrMov_par%n2-1)/2

        CorrMov_par%n2=CorrMov_par%n3
        CorrMov_par%n3=CorrMov_par%n4
        CorrMov_par%n4=CorrMov_par%n5
        CorrMov_par%n5=CorrMov_par%n6

        CorrMov_par%o2=CorrMov_par%o3
        CorrMov_par%o3=CorrMov_par%o4
        CorrMov_par%o4=CorrMov_par%o5
        CorrMov_par%o5=CorrMov_par%o6

        CorrMov_par%d2=CorrMov_par%d3
        CorrMov_par%d3=CorrMov_par%d4
        CorrMov_par%d4=CorrMov_par%d5
        CorrMov_par%d5=CorrMov_par%d6

        call to_history("n1",CorrMov_par%n1)
        call to_history("n2",CorrMov_par%n2)
        call to_history("n3",CorrMov_par%n3)
        call to_history("n4",CorrMov_par%n4)
        call to_history("n5",CorrMov_par%n5)
  
        call to_history("o1",CorrMov_par%o1)
        call to_history("o2",CorrMov_par%o2)
        call to_history("o3",CorrMov_par%o3)
        call to_history("o4",CorrMov_par%o4)
        call to_history("o5",CorrMov_par%o5)
  
        call to_history("d1",CorrMov_par%d1)
        call to_history("d2",CorrMov_par%d2)
        call to_history("d3",CorrMov_par%d3)
        call to_history("d4",CorrMov_par%d4)
        call to_history("d5",CorrMov_par%d5)

      !}
      else
      !{

        call from_param('h_width_bform',CorrMov_par%h_width_bform)

        call to_history("title","Beam-forming (fwd)")
  
        call to_history("n1",CorrMov_par%n1)
        call to_history("n2",(1+2*CorrMov_par%h_width_bform))
        call to_history("n3",CorrMov_par%n2)
        call to_history("n4",CorrMov_par%n3)
        call to_history("n5",CorrMov_par%n4)
        call to_history("n6",CorrMov_par%n5)
  
        call to_history("o1",CorrMov_par%o1)
        call to_history("o2",-CorrMov_par%h_width_bform*CorrMov_par%d2)
        call to_history("o3",CorrMov_par%o2)
        call to_history("o4",CorrMov_par%o3)
        call to_history("o5",CorrMov_par%o4)
        call to_history("o6",CorrMov_par%o5)
  
        call to_history("d1",CorrMov_par%d1)
        call to_history("d2",CorrMov_par%d2)
        call to_history("d3",CorrMov_par%d2)
        call to_history("d4",CorrMov_par%d3)
        call to_history("d5",CorrMov_par%d4)
        call to_history("d6",CorrMov_par%d5)
      !}
      end if

!      call from_param('bstack_threshold',CorrMov_par%bstack_threshold,-1.)
!
      call from_param('bform_min1',CorrMov_par%bform_min1,CorrMov_par%o1)
      call from_param('bform_max1',CorrMov_par%bform_max1, &
               CorrMov_par%o1+(CorrMov_par%n1-1)*CorrMov_par%d1)
      call from_param('bform_min2',CorrMov_par%bform_min2,CorrMov_par%o2)
      call from_param('bform_max2',CorrMov_par%bform_max2, &
               CorrMov_par%o2+(CorrMov_par%n2-1)*CorrMov_par%d2)
!
      call from_param('r_weights_bform',CorrMov_par%r_weights_bform,.false.)
      call from_param('l_weights_bform',CorrMov_par%l_weights_bform,.false.)

      if(CorrMov_par%r_weights_bform) then
      !{
        call from_param('bform_epsi',CorrMov_par%bform_epsi,.001)

        call from_param('tag_r_weights',CorrMov_par%tag_r_weights,'R_Weights')
        call from_param(trim(CorrMov_par%tag_r_weights), &
              tag_name,'R_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_r_weights))
!        write(0,*)'auxin ierr=',ierr
!        write(0,*)'tag_r_weights=',trim(CorrMov_par%tag_r_weights)

        call from_aux(trim(CorrMov_par%tag_r_weights),"n1",n1)
!        write(0,*)'n1 =',n1
        call from_aux(trim(CorrMov_par%tag_r_weights),"n2",n2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n3",n3,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"n4",n4,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o2",o2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o3",o3,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"o4",o4,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_r_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d2",d2)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d3",d3,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_r_weights),"d4",d4,CorrMov_par%d5)

        if (n1 /= CorrMov_par%n2) then
          write(0,*)'R_Weights: n1=',n1,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n3) then
          write(0,*)'R_Weights: n2=',n2,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n4) then
          write(0,*)'R_Weights: n3=',n3,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n5) then
          write(0,*)'R_Weights: n4=',n4,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= CorrMov_par%o2) then
          write(0,*)'R_Weights: o1=',o1,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o3) then
          write(0,*)'R_Weights: o2=',o2,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o4) then
          write(0,*)'R_Weights: o3=',o3,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o5) then
          write(0,*)'R_Weights: o4=',o4,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'R_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d3) then
          write(0,*)'R_Weights: d2=',d2,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d4) then
          write(0,*)'R_Weights: d3=',d3,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d5) then
          write(0,*)'R_Weights: d4=',d4,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if

      if(CorrMov_par%l_weights_bform) then
      !{
        call from_param('tag_l_weights',CorrMov_par%tag_l_weights,'L_Weights')
        call from_param(trim(CorrMov_par%tag_l_weights), &
              tag_name,'L_Weights not found')
        ierr=auxin(trim(CorrMov_par%tag_l_weights))
!        write(0,*)'auxin ierr=',ierr

        call from_aux(trim(CorrMov_par%tag_l_weights),"n1",n1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n2",n2,CorrMov_par%n2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n3",n3,CorrMov_par%n3)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n4",n4,CorrMov_par%n4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"n5",n5,CorrMov_par%n5)

        call from_aux(trim(CorrMov_par%tag_l_weights),"o1",o1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o2",o2,CorrMov_par%o2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o3",o3,CorrMov_par%o3)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o4",o4,CorrMov_par%o4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"o5",o5,CorrMov_par%o5)

        call from_aux(trim(CorrMov_par%tag_l_weights),"d1",d1)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d2",d2,CorrMov_par%d2)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d3",d3,CorrMov_par%d3)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d4",d4,CorrMov_par%d4)
        call from_aux(trim(CorrMov_par%tag_l_weights),"d5",d5,CorrMov_par%d5)

        if (n1 /= 1+2*CorrMov_par%h_width_bform) then
        call to_history("n2",(1+2*CorrMov_par%h_width_bform))
          write(0,*)'L_Weights: n1=',n1,'should be=',1+2*CorrMov_par%h_width_bform
          call seperr ("These dimensions should be the same")
        end if
        if (n2 /= CorrMov_par%n2) then
          write(0,*)'L_Weights: n2=',n2,'Data: n2=',CorrMov_par%n2
          call seperr ("These dimensions should be the same")
        end if
        if (n3 /= CorrMov_par%n3) then
          write(0,*)'L_Weights: n3=',n3,'Data: n3=',CorrMov_par%n3
          call seperr ("These dimensions should be the same")
        end if
        if (n4 /= CorrMov_par%n4) then
          write(0,*)'L_Weights: n4=',n4,'Data: n4=',CorrMov_par%n4
          call seperr ("These dimensions should be the same")
        end if
        if (n5 /= CorrMov_par%n5) then
          write(0,*)'L_Weights: n5=',n5,'Data: n5=',CorrMov_par%n5
          call seperr ("These dimensions should be the same")
        end if

        if (o1 /= -CorrMov_par%h_width_bform*CorrMov_par%d2) then
          write(0,*)'L_Weights: o1=',o1,'should be=',-CorrMov_par%h_width_bform*CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (o2 /= CorrMov_par%o2) then
          write(0,*)'L_Weights: o2=',o3,'Data: o2=',CorrMov_par%o2
          call seperr ("These dimensions should be the same")
        end if
        if (o3 /= CorrMov_par%o3) then
          write(0,*)'L_Weights: o3=',o3,'Data: o3=',CorrMov_par%o3
          call seperr ("These dimensions should be the same")
        end if
        if (o4 /= CorrMov_par%o4) then
          write(0,*)'L_Weights: o4=',o4,'Data: o4=',CorrMov_par%o4
          call seperr ("These dimensions should be the same")
        end if
        if (o5 /= CorrMov_par%o5) then
          write(0,*)'L_Weights: o5=',o5,'Data: o5=',CorrMov_par%o5
          call seperr ("These dimensions should be the same")
        end if

        if (d1 /= CorrMov_par%d2) then
          write(0,*)'L_Weights: d1=',d1,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d2 /= CorrMov_par%d2) then
          write(0,*)'L_Weights: d2=',d2,'Data: d2=',CorrMov_par%d2
          call seperr ("These dimensions should be the same")
        end if
        if (d3 /= CorrMov_par%d3) then
          write(0,*)'L_Weights: d3=',d3,'Data: d3=',CorrMov_par%d3
          call seperr ("These dimensions should be the same")
        end if
        if (d4 /= CorrMov_par%d4) then
          write(0,*)'L_Weights: d4=',d4,'Data: d4=',CorrMov_par%d4
          call seperr ("These dimensions should be the same")
        end if
        if (d5 /= CorrMov_par%d5) then
          write(0,*)'L_Weights: d5=',d5,'Data: d5=',CorrMov_par%d5
          call seperr ("These dimensions should be the same")
        end if
      !}
      end if


    !}

    case default
       write(0,*)'CorrMov_par-oper_type=',trim(CorrMov_par%oper_type)
       call seperr('Not supported oper_type')
    end select

  return

end subroutine param_CorrMov
